autofs-5.1.8 - simplify cache_add() a little

From: Ian Kent <raven@themaw.net>

If a map entry is being added to an existing hash chain there's an
unneccessarily complicted setting of ->next of the last entry.

Just initialize the map entry ->next field instead and remove the
confusing assignment.

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG   |    1 +
 lib/cache.c |    2 +-
 2 files changed, 2 insertions(+), 1 deletion(-)

diff --git a/CHANGELOG b/CHANGELOG
index 4e5e82d0..5b37460f 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -9,6 +9,7 @@
 - fix loop under run in cache_get_offset_parent().
 - bailout on rpc systemerror.
 - fix nfsv4 only mounts should not use rpcbind.
+- simplify cache_add() a little.
 
 19/10/2021 autofs-5.1.8
 - add xdr_exports().
diff --git a/lib/cache.c b/lib/cache.c
index 8aed28ea..4f908daf 100644
--- a/lib/cache.c
+++ b/lib/cache.c
@@ -564,6 +564,7 @@ int cache_add(struct mapent_cache *mc, struct map_source *ms, const char *key, c
 	me->dev = (dev_t) -1;
 	me->ino = (ino_t) -1;
 	me->flags = 0;
+	me->next = NULL;
 
 	/* 
 	 * We need to add to the end if values exist in order to
@@ -583,7 +584,6 @@ int cache_add(struct mapent_cache *mc, struct map_source *ms, const char *key, c
 
 			existing = next;
 		}
-		me->next = existing->next;
 		existing->next = me;
 	}
 	return CHE_OK;
